- [HTTP request](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#body.QueryFormabilityResponse.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#body.QueryFormabilityResponse.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION)
      - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#body.QueryFormabilityResponse.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION)
        - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#body.QueryFormabilityResponse.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION)
        - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#body.QueryFormabilityResponse.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION_1)
        - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#body.QueryFormabilityResponse.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION_2)
        - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#body.QueryFormabilityResponse.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION.error.SCHEMA_REPRESENTATION.error_details.SCHEMA_REPRESENTATION_3)
- [Authorization scopes](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#body.aspect_1)
- [Try it!](https://docs.cloud.google.com/compute/docs/reference/rest/2026-10-01-preview/acceleratorInterconnects/queryFormability#try-it)

API Version : 2026-10-01-preview
Queries hierarchical formability over dense reservations.

### HTTP request

Choose an endpoint:
global africa-south1 asia-east1 asia-east2 asia-northeast1 asia-northeast2 asia-northeast3 asia-south1 asia-south2 asia-southeast1 asia-southeast2 asia-southeast3 australia-southeast1 australia-southeast2 europe-central2 europe-north1 europe-north2 europe-southwest1 europe-west1 europe-west10 europe-west12 europe-west2 europe-west3 europe-west4 europe-west6 europe-west8 europe-west9 me-central1 me-central2 me-west1 northamerica-northeast1 northamerica-northeast2 northamerica-south1 southamerica-east1 southamerica-west1 us-central1 us-east1 us-east4 us-east5 us-south1 us-west1 us-west2 us-west3 us-west4   
`POST https://compute.googleapis.com/compute/v1/projects/{project}/zones/{zone}/acceleratorInterconnects:queryFormability?$apiVersion=2026-10-01-preview`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` Project ID for this request. |
| `zone` | `string` The name of the [zone](https://docs.cloud.google.com/compute/docs/regions-zones#available) where the request is located. Zone name should conform to RFC1035. |

### Query parameters

| Parameters ||
|---|---|
| `maxResults` | `integer (https://developers.google.com/discovery/v1/type-format format)` The maximum number of results per page that should be returned. If the number of available results is larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`) |
| `pageToken` | `string` Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list request to get the next page of results. |
| `filter` | `string` A filter expression that filters resources listed in the response. Most Compute resources support two types of filter expressions: expressions that support regular expressions and expressions that follow API improvement proposal [AIP-160](https://google.aip.dev/160). These two types of filter expressions cannot be mixed in one request. If you want to use AIP-160, your expression must specify the field name, an operator, and the value that you want to use for filtering. The value must be a string, a number, or a boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or `:`. For example, if you are filtering Compute Engine instances, you can exclude instances named `example-instance` by specifying `name != example-instance`. The `:*` comparison can be used to test whether a key has been defined. For example, to find all objects with `owner` label use: labels.owner:* You can also filter nested fields. For example, you could specify `scheduling.automaticRestart = false` to include instances only if they are not scheduled for automatic restarts. You can use filtering on nested fields to filter based on [resource labels](https://docs.cloud.google.com/compute/docs/labeling-resources). To filter on multiple expressions, provide each separate expression within parentheses. For example: (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") By default, each expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For example: (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true) If you want to use a regular expression, use the `eq` (equal) or `ne` (not equal) operator against a single un-parenthesized expression with or without quotes or against multiple parenthesized expressions. Examples: `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'` `fieldname eq "double quoted literal"` `(fieldname1 eq literal) (fieldname2 ne "literal")` The literal value is interpreted as a regular expression using Google [RE2](https://github.com/google/re2/wiki/Syntax) library syntax. The literal value must match the entire field. For example, to filter for instances that do not end with name "instance", you would use `name ne .*instance`. You cannot combine constraints on multiple fields using regular expressions. |
| `orderBy` | `string` Sorts list results by a certain order. By default, results are returned in alphanumerical order based on the resource name. You can also sort results in descending order based on the creation timestamp using `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse chronological order (newest result first). Use this to sort resources like operations so that the newest operation is returned first. Currently, only sorting by `name` or `creationTimestamp desc` is supported. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "subblocks": [ string ] } ``` |

| Fields ||
|---|---|
| `subblocks[]` | `string` Explicit list of fully qualified reservation subblock resource URLs. Both full and relative URIs are supported. |

### Response body

Response message for AcceleratorInterconnects.QueryFormability.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "items": [ { "partitionId": string, "acceleratorTopology": string, "status": { "state": enum, "infrastructureHealth": enum, "instanceState": enum, "usageState": enum, "acceleratorInterconnect": string, "instance": string, "error": { "errors": [ { "code": string, "location": string, "message": string, "errorDetails": [ { "errorInfo": { "reason": string, "domain": string, "metadatas": { string: string, ... } }, "quotaInfo": { "metricName": string, "limitName": string, "dimensions": { string: string, ... }, "limit": number, "futureLimit": number, "rolloutStatus": enum }, "help": { "links": [ { "description": string, "url": string } ] }, "localizedMessage": { "locale": string, "message": string } } ] } ] } }, "parent": string, "subblock": string } ], "nextPageToken": string } ``` |

| Fields ||
|---|---|
| `items[]` | `object` Flattened collection of hierarchical partitions and their formability across all requested subblocks. Available from version 2026-10-01-preview. |
| `items[].partitionId` | `string` Identifier for this topological block. |
| `items[].acceleratorTopology` | `string` Topological shape (e.g., "4x4x4"). |
| `items[].status` | `object` Output only. Defines the status of the partition. |
| `items[].status.state` | `enum` Current formability state. |
| `items[].status.infrastructureHealth` | `enum` Physical health of the underlying infrastructure. |
| `items[].status.instanceState` | `enum` State of the instances within this partition. |
| `items[].status.usageState` | `enum` Usage state indicating if the partition is occupied. |
| `items[].status.acceleratorInterconnect` | `string` URL of the AcceleratorInterconnect utilizing this partition. |
| `items[].status.instance` | `string` URL of an instance provisioned in a single-host partitionID at the lowest level of the partition tree. Empty if the instance is missing. |
| `items[].status.error` | `object` Detailed error status if the subblock has wrong or no provisioning. When set, only subblock and error are populated. |
| `items[].status.error.errors[]` | `object` Output only. The array of errors encountered while processing this operation. |
| `items[].status.error.errors[].code` | `string` Output only. The error type identifier for this error. |
| `items[].status.error.errors[].location` | `string` Output only. Indicates the field in the request that caused the error. This property is optional. |
| `items[].status.error.errors[].message` | `string` Output only. An optional, human-readable error message. |
| `items[].status.error.errors[].errorDetails[]` | `object` Output only. An optional list of messages that contain the error details. There is a set of defined message types to use for providing details.The syntax depends on the error code. For example, QuotaExceededInfo will have details when the error code is QUOTA_EXCEEDED. |
| `items[].status.error.errors[].errorDetails[].errorInfo` | `object` Error information containing structured domain, reason, and metadata. |
| `items[].status.error.errors[].errorDetails[].errorInfo.reason` | `string` The reason of the error. This is a constant value that identifies the proximate cause of the error. Error reasons are unique within a particular domain of errors. This should be at most 63 characters and match a regular expression of `[A-Z][A-Z0-9_]+[A-Z0-9]`, which represents UPPER_SNAKE_CASE. |
| `items[].status.error.errors[].errorDetails[].errorInfo.domain` | `string` The logical grouping to which the "reason" belongs. The error domain is typically the registered service name of the tool or product that generates the error. Example: "pubsub.googleapis.com". If the error is generated by some common infrastructure, the error domain must be a globally unique value that identifies the infrastructure. For Google API infrastructure, the error domain is "googleapis.com". |
| `items[].status.error.errors[].errorDetails[].errorInfo.metadatas` | `map (key: string, value: string)` Additional structured details about this error. Keys must match a regular expression of `[a-z][a-zA-Z0-9-_]+` but should ideally be lowerCamelCase. Also, they must be limited to 64 characters in length. When identifying the current value of an exceeded limit, the units should be contained in the key, not the value. For example, rather than `{"instanceLimit": "100/request"}`, should be returned as, `{"instanceLimitPerRequest": "100"}`, if the client exceeds the number of instances that can be created in a single (batch) request. |
| `items[].status.error.errors[].errorDetails[].quotaInfo` | `object` Details about quota limits and metrics when a quota is exceeded. |
| `items[].status.error.errors[].errorDetails[].quotaInfo.metricName` | `string` The Compute Engine quota metric name. |
| `items[].status.error.errors[].errorDetails[].quotaInfo.limitName` | `string` The name of the quota limit. |
| `items[].status.error.errors[].errorDetails[].quotaInfo.dimensions` | `map (key: string, value: string)` The map holding related quota dimensions. |
| `items[].status.error.errors[].errorDetails[].quotaInfo.limit` | `number` Current effective quota limit. The limit's unit depends on the quota type or metric. |
| `items[].status.error.errors[].errorDetails[].quotaInfo.futureLimit` | `number` Future quota limit being rolled out. The limit's unit depends on the quota type or metric. |
| `items[].status.error.errors[].errorDetails[].quotaInfo.rolloutStatus` | `enum` Rollout status of the future quota limit. |
| `items[].status.error.errors[].errorDetails[].help` | `object` Links and information to help the user resolve the error. |
| `items[].status.error.errors[].errorDetails[].help.links[]` | `object` URL(s) pointing to additional information on handling the current error. |
| `items[].status.error.errors[].errorDetails[].help.links[].description` | `string` Describes what the link offers. |
| `items[].status.error.errors[].errorDetails[].help.links[].url` | `string` The URL of the link. |
| `items[].status.error.errors[].errorDetails[].localizedMessage` | `object` A localized human-readable error message intended for end users. |
| `items[].status.error.errors[].errorDetails[].localizedMessage.locale` | `string` The locale used following the specification defined at <https://www.rfc-editor.org/rfc/bcp/bcp47.txt>. Examples are: "en-US", "fr-CH", "es-MX" |
| `items[].status.error.errors[].errorDetails[].localizedMessage.message` | `string` The localized error message in the above locale. |
| `items[].parent` | `string` Partition ID of a partition that is a direct parent in the tree hierarchy. In case the partition represents a full cube, it doesn't have a parent field. |
| `items[].subblock` | `string` The URL of the capacity subblock. |
| `nextPageToken` | `string` This token allows you to get the next page of results for list requests. If the number of results is larger than `maxResults`, use the `nextPageToken` as a value for the query parameter `pageToken` in the next list request. Subsequent list requests will have their own `nextPageToken` to continue paging through the results. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/compute`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

In addition to any permissions specified on the fields above, authorization requires one or more of the following [IAM](https://cloud.google.com/iam/docs/) permissions:

- `compute.acceleratorInterconnects.queryFormability`

To find predefined roles that contain those permissions, see [Compute Engine IAM Roles](https://docs.cloud.google.com/compute/docs/access/iam).